package envoy.server.processors;

import java.io.IOException;
import java.util.stream.Collectors;

import envoy.data.Contacts;
import envoy.event.ContactsRequest;
import envoy.server.ObjectProcessor;
import envoy.server.database.PersistenceManager;
import envoy.server.net.ObjectWriteProxy;

/**
 * Project: <strong>envoy-server-standalone</strong><br>
 * File: <strong>ContactsRequestProcesor.java</strong><br>
 * Created: <strong>08.02.2020</strong><br>
 * 
 * @author Kai S. K. Engelbart
 * @since Envoy Server Standalone v0.1-alpha
 */
public class ContactsRequestProcesor implements ObjectProcessor<ContactsRequest> {

	@Override
	public void process(ContactsRequest request, long socketId, ObjectWriteProxy writeProxy) throws IOException {
		writeProxy.write(socketId,
				new Contacts(PersistenceManager.getPersistenceManager()
					.searchUsers(request.get())
					.stream()
					.map(envoy.server.data.User::toCommonUser)
					.collect(Collectors.toList())));
	}

	@Override
	public Class<ContactsRequest> getInputClass() { return ContactsRequest.class; }
}
